List managed keys

GET /v4/managed_keys

List all managed keys in the instance. It is possible to sort by the following parameters: label, algorithm, state, activation_date, deactivation_date, created_at, updated_at, size, vault.id.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

Query Parameters

vault.id

array

The UUID of the Vault.

algorithm

array

The algorithm of a returned key.

state

array

The state that returned keys are to be in.

limit

integer

The number of resources to retrieve.

offset

integer

The number of resources to skip.

sort

array

Define sorting order

label

string

The label of the key

activation_date

string

Return only managed keys whose activation_date matches the parameter.

activation_date_min

string

Return only managed keys whose activation_date is at or after the parameter value. This query parameter cannot be used in conjunction with the 'activation_date' query parameter.

activation_date_max

string

Return only managed keys whose activation_date is at or before the parameter value. This query parameter cannot be used in conjunction with the 'activation_date' query parameter.

deactivation_date

string

Return only managed keys whose deactivation_date matches the parameter. This query parameter cannot be used in conjunction with the 'expiration_date' query parameter.

deactivation_date_min

string

Return only managed keys whose deactivation_date is at or after the parameter value. This query parameter cannot be used in conjunction with the 'deactivation_date', 'expiration_date', 'expiration_date_min' and 'expiration_date_max' query parameters.

deactivation_date_max

string

Return only managed keys whose deactivation_date is at or before the parameter value. This query parameter cannot be used in conjunction with the 'deactivation_date', 'expiration_date', 'expiration_date_min' and 'expiration_date_max' query parameters.

expiration_date

string

Return only managed keys whose deactivation_date matches the parameter.

expiration_date_min

string

Return only managed keys whose deactivation_date is at or after the parameter value. This query parameter cannot be used in conjunction with the 'deactivation_date', 'expiration_date', 'deactivation_date_min' and 'deactivation_date_max' query parameters.

expiration_date_max

string

Return only managed keys whose deactivation_date is at or before the parameter value. This query parameter cannot be used in conjunction with the 'deactivation_date', 'expiration_date', 'deactivation_date_min' and 'deactivation_date_max' query parameters.

created_at

string

Return only managed keys whose created_at matches the parameter.

created_at_min

string

Return only managed keys whose created_at is at or after the parameter value. This query parameter cannot be used in conjunction with the 'created_at' query parameter.

created_at_max

string

Return only managed keys whose created_at is at or before the parameter value. This query parameter cannot be used in conjunction with the 'created_at' query parameter.

updated_at

string

Return only managed keys whose updated_at matches the parameter.

updated_at_min

string

Return only managed keys whose updated_at is after the parameter value. This query parameter cannot be used in conjunction with the 'updated_at' query parameter.

updated_at_max

string

Return only managed keys whose updated_at is before the parameter value. This query parameter cannot be used in conjunction with the 'updated_at' query parameter.

rotated_at_min

string

Return only managed keys whose rotated_at is after the parameter value.

rotated_at_max

string

Return only managed keys whose rotated_at is before the parameter value.

size

string

The size of the key

size_min

string

The minimum size of the key. This query parameter cannot be used in conjunction with the 'size' query parameter.

size_max

string

The maximum size of the key. This query parameter cannot be used in conjunction with the 'size' query parameter.

referenced_keystores[].type

array

Type of referenced keystore. This query parameter cannot be used in conjunction with the 'instances[].keystore.type' query parameter.

referenced_keystores[].name

array

Name of referenced keystore

instances[].keystore.type

array

Type of keystore supported by one of the instances. This query parameter cannot be used in conjunction with the 'referenced_keystores[].type' query parameter.

template.name

string

Return only managed keys whose template name begins with the string.

template.id

array

Return only managed keys with the given template UUID.

template.type[]

array

Return only managed keys with the given template type.

Response

200 - OK

total_count

integer

The total count of all objects in the entire collection.

limit

integer

The number of resources that were requested in this query.

offset

integer

The number of resources that were skipped in this query.

first

hrefObject

URL of a resource

last

hrefObject

URL of a resource

previous

hrefObject

URL of a resource

next

hrefObject

URL of a resource

managed_keys

array

A list of managed keys

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Create a managed key

POST /v4/managed_keys

Creates a new key based on the supplied template. The template must exist in the system prior to this call.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Request Body

keyCreationRequest

Parameters required to create a key

template_name

Required *

string

Name of the key template to use when creating a key

vault

Required *

vaultReferenceInCreationRequest

ID of the Vault where the entity is to be created in

id

Required *

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

label

string

The label of the key.

tags

array

label_tags

array

description

string

Description of the managed key

Response

201 - OK

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

vault

vaultReference

Reference to a vault

template

templateReference

Reference to a key template

version

integer

description

string

Description of the managed key

label

string

The label of the key.

state

string

The state of the key

size

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

algorithm

string

The algorithm of the key

verification_patterns

array

A list of verification patterns of the key (e.g. public key hash for RSA keys)

activation_date

string

First day when the key is active

expiration_date

string

Last day when the key is active

label_tags

array

tags

array

created_at

string

Date and time when the key was created

updated_at

string

Date and time when the key was last updated

created_by

string

ID of the user that created the key

updated_by

string

ID of the user that last updated the key

referenced_keystores

array

referenced keystores

instances

array

key instances

href

string

A URL that uniquely identifies your cloud resource.

rotated_at

string

Date and time when the key was rotated

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - Key with a given label already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

424 - One or more keystores defined by the keystore tag is not available. Inspect response body for details.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Delete a managed key

DELETE /v4/managed_keys/{id}

Delete a managed key by ID from the vault. A key must be in a 'destroyed' state for it to be eligible for deletion.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

Response

204 - Deletion successful

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Retrieve a managed key

GET /v4/managed_keys/{id}

Retrieve a managed key and its details by specifying the ID.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

Response

200 - OK

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

vault

vaultReference

Reference to a vault

template

templateReference

Reference to a key template

version

integer

description

string

Description of the managed key

label

string

The label of the key.

state

string

The state of the key

size

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

algorithm

string

The algorithm of the key

verification_patterns

array

A list of verification patterns of the key (e.g. public key hash for RSA keys)

activation_date

string

First day when the key is active

expiration_date

string

Last day when the key is active

label_tags

array

tags

array

created_at

string

Date and time when the key was created

updated_at

string

Date and time when the key was last updated

created_by

string

ID of the user that created the key

updated_by

string

ID of the user that last updated the key

referenced_keystores

array

referenced keystores

instances

array

key instances

href

string

A URL that uniquely identifies your cloud resource.

rotated_at

string

Date and time when the key was rotated

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Update a managed key

PATCH /v4/managed_keys/{id}

Update attributes of a managed key. It is only possible to modify the key's state separately from other changes. Changing a key's state affects its availablity for crypto operations in keystores.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Request Body

keyUpdateRequest

Updated parameters of the key

label

string

The label of the key.

activation_date

string

Activation date provided in format: YYYY-MM-DD

expiration_date

string

Expiration date provided in format: YYYY-MM-DD

tags

array

label_tags

array

description

string

Updated description of the managed key

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

Response

200 - OK

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

vault

vaultReference

Reference to a vault

template

templateReference

Reference to a key template

version

integer

description

string

Description of the managed key

label

string

The label of the key.

state

string

The state of the key

size

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

algorithm

string

The algorithm of the key

verification_patterns

array

A list of verification patterns of the key (e.g. public key hash for RSA keys)

activation_date

string

First day when the key is active

expiration_date

string

Last day when the key is active

label_tags

array

tags

array

created_at

string

Date and time when the key was created

updated_at

string

Date and time when the key was last updated

created_by

string

ID of the user that created the key

updated_by

string

ID of the user that last updated the key

referenced_keystores

array

referenced keystores

instances

array

key instances

href

string

A URL that uniquely identifies your cloud resource.

rotated_at

string

Date and time when the key was rotated

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

List associated resources for a managed key

GET /v4/managed_keys/{id}/associated_resources

You can use this endpoint to obtain a list of resources associated with this managed key in IBM Cloud; which cloud resources are protected by the key you specify.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

limit

integer

The number of resources to retrieve.

offset

integer

The number of resources to skip.

sort

array

Define sorting order

Response

200 - OK

total_count

integer

The total count of all objects in the entire collection.

limit

integer

The number of resources that were requested in this query.

offset

integer

The number of resources that were skipped in this query.

first

hrefObject

URL of a resource

last

hrefObject

URL of a resource

previous

hrefObject

URL of a resource

next

hrefObject

URL of a resource

associated_resources

array

A list of associated resources.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Update a managed key to match the key template

POST /v4/managed_keys/{id}/update_from_template

Update a managed key to match the latest version of the associated key template. It will install, activate, or deactivate the key on target keystores in the group defined by the key template.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

dry_run

boolean

Do not create/update/delete a resource, only verify and validate if resource can be created/updated/deleted with given request successfully.

Response

200 - OK

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

vault

vaultReference

Reference to a vault

template

templateReference

Reference to a key template

version

integer

description

string

Description of the managed key

label

string

The label of the key.

state

string

The state of the key

size

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

algorithm

string

The algorithm of the key

verification_patterns

array

A list of verification patterns of the key (e.g. public key hash for RSA keys)

activation_date

string

First day when the key is active

expiration_date

string

Last day when the key is active

label_tags

array

tags

array

created_at

string

Date and time when the key was created

updated_at

string

Date and time when the key was last updated

created_by

string

ID of the user that created the key

updated_by

string

ID of the user that last updated the key

referenced_keystores

array

referenced keystores

instances

array

key instances

href

string

A URL that uniquely identifies your cloud resource.

rotated_at

string

Date and time when the key was rotated

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Activate a managed key

POST /v4/managed_keys/{id}/activate

Activate a managed key and perform key installation or activation operations on keystores in the keystore group associated with the managed key.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

Response

200 - OK

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

vault

vaultReference

Reference to a vault

template

templateReference

Reference to a key template

version

integer

description

string

Description of the managed key

label

string

The label of the key.

state

string

The state of the key

size

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

algorithm

string

The algorithm of the key

verification_patterns

array

A list of verification patterns of the key (e.g. public key hash for RSA keys)

activation_date

string

First day when the key is active

expiration_date

string

Last day when the key is active

label_tags

array

tags

array

created_at

string

Date and time when the key was created

updated_at

string

Date and time when the key was last updated

created_by

string

ID of the user that created the key

updated_by

string

ID of the user that last updated the key

referenced_keystores

array

referenced keystores

instances

array

key instances

href

string

A URL that uniquely identifies your cloud resource.

rotated_at

string

Date and time when the key was rotated

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Deactivate a managed key

POST /v4/managed_keys/{id}/deactivate

Deactivates a managed key and performs key deactivation operations on keystores in the keystore group associated with the managed key.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

Response

200 - OK

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

vault

vaultReference

Reference to a vault

template

templateReference

Reference to a key template

version

integer

description

string

Description of the managed key

label

string

The label of the key.

state

string

The state of the key

size

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

algorithm

string

The algorithm of the key

verification_patterns

array

A list of verification patterns of the key (e.g. public key hash for RSA keys)

activation_date

string

First day when the key is active

expiration_date

string

Last day when the key is active

label_tags

array

tags

array

created_at

string

Date and time when the key was created

updated_at

string

Date and time when the key was last updated

created_by

string

ID of the user that created the key

updated_by

string

ID of the user that last updated the key

referenced_keystores

array

referenced keystores

instances

array

key instances

href

string

A URL that uniquely identifies your cloud resource.

rotated_at

string

Date and time when the key was rotated

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Destroy a managed key

POST /v4/managed_keys/{id}/destroy

Destroy a managed key and perform key destruction operations on keystores in the keystore group associated with the managed key. This operation cannot be undone. The managed key must be in a 'deactivated' state.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

Response

200 - OK

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

vault

vaultReference

Reference to a vault

template

templateReference

Reference to a key template

version

integer

description

string

Description of the managed key

label

string

The label of the key.

state

string

The state of the key

size

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

algorithm

string

The algorithm of the key

verification_patterns

array

A list of verification patterns of the key (e.g. public key hash for RSA keys)

activation_date

string

First day when the key is active

expiration_date

string

Last day when the key is active

label_tags

array

tags

array

created_at

string

Date and time when the key was created

updated_at

string

Date and time when the key was last updated

created_by

string

ID of the user that created the key

updated_by

string

ID of the user that last updated the key

referenced_keystores

array

referenced keystores

instances

array

key instances

href

string

A URL that uniquely identifies your cloud resource.

rotated_at

string

Date and time when the key was rotated

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Sync a managed key in keystores

POST /v4/managed_keys/{id}/sync_status_in_keystores

Perform the synchronization operation on a managed key to align the states in the associated keystores.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

Response

200 - OK - It's returned when all of the statuses are successful.

status_in_keystores

array

list of key statuses in keystores

207 - Multi-Status - It's returned when some of the statuses contain errors.

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Rotate the managed key

POST /v4/managed_keys/{id}/rotate

Rotate the managed key

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

Response

200 - OK

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

vault

vaultReference

Reference to a vault

template

templateReference

Reference to a key template

version

integer

description

string

Description of the managed key

label

string

The label of the key.

state

string

The state of the key

size

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

algorithm

string

The algorithm of the key

verification_patterns

array

A list of verification patterns of the key (e.g. public key hash for RSA keys)

activation_date

string

First day when the key is active

expiration_date

string

Last day when the key is active

label_tags

array

tags

array

created_at

string

Date and time when the key was created

updated_at

string

Date and time when the key was last updated

created_by

string

ID of the user that created the key

updated_by

string

ID of the user that last updated the key

referenced_keystores

array

referenced keystores

instances

array

key instances

href

string

A URL that uniquely identifies your cloud resource.

rotated_at

string

Date and time when the key was rotated

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

List managed key versions

GET /v4/managed_keys/{id}/versions

List all managed key versions in the instance.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

algorithm

array

The algorithm of a returned key.

state

array

The state that returned keys are to be in.

limit

integer

The number of resources to retrieve.

offset

integer

The number of resources to skip.

sort

array

Define sorting order

label

string

The label of the key

activation_date

string

Return only managed keys whose activation_date matches the parameter.

activation_date_min

string

Return only managed keys whose activation_date is at or after the parameter value. This query parameter cannot be used in conjunction with the 'activation_date' query parameter.

activation_date_max

string

Return only managed keys whose activation_date is at or before the parameter value. This query parameter cannot be used in conjunction with the 'activation_date' query parameter.

deactivation_date

string

Return only managed keys whose deactivation_date matches the parameter. This query parameter cannot be used in conjunction with the 'expiration_date' query parameter.

deactivation_date_min

string

Return only managed keys whose deactivation_date is at or after the parameter value. This query parameter cannot be used in conjunction with the 'deactivation_date', 'expiration_date', 'expiration_date_min' and 'expiration_date_max' query parameters.

deactivation_date_max

string

Return only managed keys whose deactivation_date is at or before the parameter value. This query parameter cannot be used in conjunction with the 'deactivation_date', 'expiration_date', 'expiration_date_min' and 'expiration_date_max' query parameters.

expiration_date

string

Return only managed keys whose deactivation_date matches the parameter.

expiration_date_min

string

Return only managed keys whose deactivation_date is at or after the parameter value. This query parameter cannot be used in conjunction with the 'deactivation_date', 'expiration_date', 'deactivation_date_min' and 'deactivation_date_max' query parameters.

expiration_date_max

string

Return only managed keys whose deactivation_date is at or before the parameter value. This query parameter cannot be used in conjunction with the 'deactivation_date', 'expiration_date', 'deactivation_date_min' and 'deactivation_date_max' query parameters.

created_at

string

Return only managed keys whose created_at matches the parameter.

created_at_min

string

Return only managed keys whose created_at is at or after the parameter value. This query parameter cannot be used in conjunction with the 'created_at' query parameter.

created_at_max

string

Return only managed keys whose created_at is at or before the parameter value. This query parameter cannot be used in conjunction with the 'created_at' query parameter.

updated_at

string

Return only managed keys whose updated_at matches the parameter.

updated_at_min

string

Return only managed keys whose updated_at is after the parameter value. This query parameter cannot be used in conjunction with the 'updated_at' query parameter.

updated_at_max

string

Return only managed keys whose updated_at is before the parameter value. This query parameter cannot be used in conjunction with the 'updated_at' query parameter.

rotated_at_min

string

Return only managed keys whose rotated_at is after the parameter value.

rotated_at_max

string

Return only managed keys whose rotated_at is before the parameter value.

size

string

The size of the key

size_min

string

The minimum size of the key. This query parameter cannot be used in conjunction with the 'size' query parameter.

size_max

string

The maximum size of the key. This query parameter cannot be used in conjunction with the 'size' query parameter.

referenced_keystores[].type

array

Type of referenced keystore. This query parameter cannot be used in conjunction with the 'instances[].keystore.type' query parameter.

referenced_keystores[].name

array

Name of referenced keystore

instances[].keystore.type

array

Type of keystore supported by one of the instances. This query parameter cannot be used in conjunction with the 'referenced_keystores[].type' query parameter.

template.name

string

Return only managed keys whose template name begins with the string.

template.id

array

Return only managed keys with the given template UUID.

template.type[]

array

Return only managed keys with the given template type.

Response

200 - OK

total_count

integer

The total count of all objects in the entire collection.

limit

integer

The number of resources that were requested in this query.

offset

integer

The number of resources that were skipped in this query.

first

hrefObject

URL of a resource

last

hrefObject

URL of a resource

previous

hrefObject

URL of a resource

next

hrefObject

URL of a resource

managed_keys

array

A list of managed keys

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Retrieve distribution status for all keystores

GET /v4/managed_keys/{id}/status_in_keystores

Return distribution status for all keystores for a key instance. If there's any problems reading the keystore status of the key instance, http code 200 will still be returned, and the error code will be returned alongside an 'error' keystore status.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the key

Query Parameters

Response

200 - OK

status_in_keystores

array

list of key statuses in keystores

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

List key templates

GET /v4/templates

List all key templates in the instance.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

Query Parameters

name

string

Return only templates whose name begin with the string.

naming_scheme

string

Return only templates whose naming scheme contains the string.

vault.id

array

The UUID of the Vault.

key.algorithm

array

The algorithm of a returned key template.

key.size

string

The size of the key

key.size_min

string

The minimum size of the key. This query parameter cannot be used in conjunction with the 'key.size' query parameter.

key.size_max

string

The maximum size of the key. This query parameter cannot be used in conjunction with the 'key.size' query parameter.

keystores[].type

array

Type of referenced keystore.

keystores[].group

array

Group of referenced keystore.

created_at

string

Return only managed keys whose created_at matches the parameter.

created_at_min

string

Return only managed keys whose created_at is at or after the parameter value. This query parameter cannot be used in conjunction with the 'created_at' query parameter.

created_at_max

string

Return only managed keys whose created_at is at or before the parameter value. This query parameter cannot be used in conjunction with the 'created_at' query parameter.

updated_at

string

Return only managed keys whose updated_at matches the parameter.

updated_at_min

string

Return only managed keys whose updated_at is after the parameter value. This query parameter cannot be used in conjunction with the 'updated_at' query parameter.

updated_at_max

string

Return only managed keys whose updated_at is before the parameter value. This query parameter cannot be used in conjunction with the 'updated_at' query parameter.

type[]

array

The types of returned templates.

state

array

Return only template whose state contains the string.

sort

array

Define sorting order

limit

integer

The number of resources to retrieve.

offset

integer

The number of resources to skip.

Response

200 - OK

total_count

integer

The total count of all objects in the entire collection.

limit

integer

The number of resources that were requested in this query.

offset

integer

The number of resources that were skipped in this query.

first

hrefObject

URL of a resource

last

hrefObject

URL of a resource

previous

hrefObject

URL of a resource

next

hrefObject

URL of a resource

templates

array

A list of key templates.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Create a key template

POST /v4/templates

Create a new key template. Key templates are used to combine information necessary when creating a key that allow easy subsequent key creation, without needing to specify any of its details.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Request Body

templateCreationRequest

Template object to be created

vault

Required *

vaultReferenceInCreationRequest

ID of the Vault where the entity is to be created in

id

Required *

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

name

Required *

string

A human-readable name to assign to your template.

description

string

Description of the key template

naming_scheme

string

Managed key naming scheme which will be applied to every key created with this template. Every tag in the naming scheme must be enclosed in angle brackets. For Every tag in the naming scheme, a value will need to be either provided by the user during key creation or computed by the service for the set of special tags.

type

array

state

string

State of the template which determines if the template is archived or unarchived.

key

Required *

keyProperties

Properties describing the properties of the managed key.

size

Required *

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

algorithm

Required *

string

The algorithm of the key

activation_date

Required *

string

Key activation date can be provided as a period definition (e.g. P1Y means 1 year).

expiration_date

Required *

string

Key expiration date can be provided as a period definition (e.g. P1Y means 1 year).

state

Required *

string

The state that the key will be in after generation

keystores

Required *

array

An array describing the type and group of target keystores the managed key is to be installed in.

Response

201 - OK

vault

vaultReference

Reference to a vault

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

version

integer

Version of the key template. Every time the key template is updated, the version will be updated automatically.

name

string

Name of the key template

naming_scheme

string

Managed key naming scheme which will be applied to every key created with this template. Every tag in the naming scheme must be enclosed in angle brackets. For Every tag in the naming scheme, a value will need to be either provided by the user during key creation or computed by the service for the set of special tags.

type

array

state

string

State of the template which determines if the template is archived or unarchived.

keys_count

integer

The total count of keys created with this template.

key

keyProperties

Properties describing the properties of the managed key.

description

string

Description of the key template

created_at

string

Date and time when the key template was created

updated_at

string

Date and time when the key template was updated

created_by

string

ID of the user that created the key template

updated_by

string

ID of the user that updated the key

keystores

array

href

string

A URL that uniquely identifies your cloud resource.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Delete a template

DELETE /v4/templates/{id}

Delete a key template from the vault. The key template must not have any managed keys associated with it for it to be eligible for deletion.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the template

Query Parameters

Response

204 - OK

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Retrieve a key template

GET /v4/templates/{id}

Retrieve a key template and its details by specifying the ID.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the template

Query Parameters

Response

200 - OK

vault

vaultReference

Reference to a vault

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

version

integer

Version of the key template. Every time the key template is updated, the version will be updated automatically.

name

string

Name of the key template

naming_scheme

string

Managed key naming scheme which will be applied to every key created with this template. Every tag in the naming scheme must be enclosed in angle brackets. For Every tag in the naming scheme, a value will need to be either provided by the user during key creation or computed by the service for the set of special tags.

type

array

state

string

State of the template which determines if the template is archived or unarchived.

keys_count

integer

The total count of keys created with this template.

key

keyProperties

Properties describing the properties of the managed key.

description

string

Description of the key template

created_at

string

Date and time when the key template was created

updated_at

string

Date and time when the key template was updated

created_by

string

ID of the user that created the key template

updated_by

string

ID of the user that updated the key

keystores

array

href

string

A URL that uniquely identifies your cloud resource.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Update a key template

PATCH /v4/templates/{id}

Update attributes of a key template.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Request Body

templateUpdateRequest

A set of properties that can be updated on template

name

string

A human-readable name to assign to your template.

keystores

array

Updated keystore related properties

description

string

Updated description of the key template

key

keyPropertiesUpdate

Updated key related properties

size

string

The size of the underlying cryptographic key or key pair. E.g. "256" for AES keys, or "2048" for RSA

activation_date

string

Key activation date can be provided as a period definition (e.g. P1Y means 1 year).

expiration_date

string

Key expiration date can be provided as a period definition (e.g. P1Y means 1 year).

state

string

The state that the key will be in after generation

Path Parameters

id

Required *

string

UUID of the template

Query Parameters

Response

200 - OK

vault

vaultReference

Reference to a vault

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

version

integer

Version of the key template. Every time the key template is updated, the version will be updated automatically.

name

string

Name of the key template

naming_scheme

string

Managed key naming scheme which will be applied to every key created with this template. Every tag in the naming scheme must be enclosed in angle brackets. For Every tag in the naming scheme, a value will need to be either provided by the user during key creation or computed by the service for the set of special tags.

type

array

state

string

State of the template which determines if the template is archived or unarchived.

keys_count

integer

The total count of keys created with this template.

key

keyProperties

Properties describing the properties of the managed key.

description

string

Description of the key template

created_at

string

Date and time when the key template was created

updated_at

string

Date and time when the key template was updated

created_by

string

ID of the user that created the key template

updated_by

string

ID of the user that updated the key

keystores

array

href

string

A URL that uniquely identifies your cloud resource.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Unarchive a key template

POST /v4/templates/{id}/unarchive

Unarchive a key template.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the template

Query Parameters

Response

200 - OK

vault

vaultReference

Reference to a vault

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

version

integer

Version of the key template. Every time the key template is updated, the version will be updated automatically.

name

string

Name of the key template

naming_scheme

string

Managed key naming scheme which will be applied to every key created with this template. Every tag in the naming scheme must be enclosed in angle brackets. For Every tag in the naming scheme, a value will need to be either provided by the user during key creation or computed by the service for the set of special tags.

type

array

state

string

State of the template which determines if the template is archived or unarchived.

keys_count

integer

The total count of keys created with this template.

key

keyProperties

Properties describing the properties of the managed key.

description

string

Description of the key template

created_at

string

Date and time when the key template was created

updated_at

string

Date and time when the key template was updated

created_by

string

ID of the user that created the key template

updated_by

string

ID of the user that updated the key

keystores

array

href

string

A URL that uniquely identifies your cloud resource.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Archive a key template

POST /v4/templates/{id}/archive

Archive a key template.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the template

Query Parameters

Response

200 - OK

vault

vaultReference

Reference to a vault

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

version

integer

Version of the key template. Every time the key template is updated, the version will be updated automatically.

name

string

Name of the key template

naming_scheme

string

Managed key naming scheme which will be applied to every key created with this template. Every tag in the naming scheme must be enclosed in angle brackets. For Every tag in the naming scheme, a value will need to be either provided by the user during key creation or computed by the service for the set of special tags.

type

array

state

string

State of the template which determines if the template is archived or unarchived.

keys_count

integer

The total count of keys created with this template.

key

keyProperties

Properties describing the properties of the managed key.

description

string

Description of the key template

created_at

string

Date and time when the key template was created

updated_at

string

Date and time when the key template was updated

created_by

string

ID of the user that created the key template

updated_by

string

ID of the user that updated the key

keystores

array

href

string

A URL that uniquely identifies your cloud resource.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Expose a key template that was previously a shadow template.

POST /v4/templates/{id}/expose

Expose a key template.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the template

Query Parameters

Response

200 - OK

vault

vaultReference

Reference to a vault

id

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

version

integer

Version of the key template. Every time the key template is updated, the version will be updated automatically.

name

string

Name of the key template

naming_scheme

string

Managed key naming scheme which will be applied to every key created with this template. Every tag in the naming scheme must be enclosed in angle brackets. For Every tag in the naming scheme, a value will need to be either provided by the user during key creation or computed by the service for the set of special tags.

type

array

state

string

State of the template which determines if the template is archived or unarchived.

keys_count

integer

The total count of keys created with this template.

key

keyProperties

Properties describing the properties of the managed key.

description

string

Description of the key template

created_at

string

Date and time when the key template was created

updated_at

string

Date and time when the key template was updated

created_by

string

ID of the user that created the key template

updated_by

string

ID of the user that updated the key

keystores

array

href

string

A URL that uniquely identifies your cloud resource.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

List all target keystores

GET /v4/keystores

List all target keystores in the instance.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

Query Parameters

type

array

Keystore type

name

string

Return only keystores whose name contains the string.

description

string

Return only keystores whose description contains the string.

group

string

A Keystore group. This query parameter cannot be used in conjunction with the 'groups[]' query parameter.

groups[]

string

Keystore groups

vault.id

array

The UUID of the Vault.

location

string

Keystore location

limit

integer

The number of resources to retrieve.

offset

integer

The number of resources to skip.

sort

array

Define sorting order

Response

200 - OK

total_count

integer

The total count of all objects in the entire collection.

limit

integer

The number of resources that were requested in this query.

offset

integer

The number of resources that were skipped in this query.

first

hrefObject

URL of a resource

last

hrefObject

URL of a resource

previous

hrefObject

URL of a resource

next

hrefObject

URL of a resource

keystores

array

A list of target keystores.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Create an internal keystore or a keystore connection

POST /v4/keystores

Create a new internal keystore or a connection to an external keystore of the requested type. If the `dry_run` query parameter is used, then a new keystore is not created in the database, only a test is performed to verify if the connection information is correct. It is possible to sort by the following parameters: name, created_at, updated_at, vault.id.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Request Body

keystoreCreationRequest

Keystore properties to update

type

Required *

string

Type of keystore

vault

Required *

vaultReferenceInCreationRequest

ID of the Vault where the entity is to be created in

id

Required *

string

The v4 UUID used to uniquely identify the resource, as specified by RFC 4122.

Path Parameters

Query Parameters

dry_run

boolean

Do not create/update/delete a resource, only verify and validate if resource can be created/updated/deleted with given request successfully.

Response

201 - OK

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

424 - Unable to establish connection to keystore with given properties

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Delete an internal keystore or a connection to an external keystore

DELETE /v4/keystores/{id}

Delete an internal keystore or a connection to an external keystore (in that case, the keystore on the remote system is unchanged).

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the keystore

Query Parameters

mode

Mode of disconnecting from keystore

Response

204 - OK

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Retrieve a target keystore

GET /v4/keystores/{id}

Retrieve a target keystore (either an internal keystore or a keystore connection) and its details by specifying the ID.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the keystore

Query Parameters

Response

200 - OK

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

Update an internal keystore or a keystore connection

PATCH /v4/keystores/{id}

Updates attributes of an internal keystore or a keystore connection.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Request Body

keystoreUpdateRequest

Keystore properties to update

Path Parameters

id

Required *

string

UUID of the keystore

Query Parameters

Response

200 - OK

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

409 - The request could not be completed due to a conflict with the current state of the target resource or because a resource with the same unique identifier (key label, keystore name) already exists.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

412 - One or more conditions given in the request header fields were evaluated with the result 'false' when tested on the server. The underlying resource may have been modified in the meantime.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

428 - The server requires the request to be conditional; use the If-Match header.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

List associated resources for a target keystore

GET /v4/keystores/{id}/associated_resources

You can use this endpoint to obtain a list of resources associated with all keys referencing this keystore.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Request

Path Parameters

id

Required *

string

UUID of the keystore

Query Parameters

limit

integer

The number of resources to retrieve.

offset

integer

The number of resources to skip.

sort

array

Define sorting order

Response

200 - OK

total_count

integer

The total count of all objects in the entire collection.

limit

integer

The number of resources that were requested in this query.

offset

integer

The number of resources that were skipped in this query.

first

hrefObject

URL of a resource

last

hrefObject

URL of a resource

previous

hrefObject

URL of a resource

next

hrefObject

URL of a resource

associated_resources

array

A list of associated resources.

400 - Bad request. At least one of the parameters or headers is invalid. Details are in the response body.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

401 - You're unauthorized to perform this operation.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

403 - You don't have sufficient permissions to the specified resource(s) to perform this operation or the operation is forbidden.

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

404 - One or more resources not found

status_code

integer

The HTTP status code used for the response

trace

string

A unique identifier that is attached to the request and the message that allows to refer to the specific transaction or the event chain.

errors

array

A list of errors

[...]
